var swatch = app.activeDocument.swatches.item("Hyphenated_AA");

if (!swatch.isValid) {
    swatch = app.activeDocument.colors.add({ name: "Hyphenated_AA" });
    swatch.space = ColorSpace.CMYK;
    swatch.colorValue = [0, 100, 100, 0];
}

//timeDiff.setStartTime();
sel = app.selection[0];
if (sel == null) {
    myDoc = app.activeDocument;
    var allStories = app.activeDocument.stories;
    for (s = 0; s < allStories.length; s++) {
        app.doScript(colorize, ScriptLanguage.JAVASCRIPT, allStories[s], UndoModes.ENTIRE_SCRIPT, "Colorize");
        //colorize(allStories[s]);
    }
}
else if (sel.constructor.name == "InsertionPoint") {
    app.doScript(colorize, ScriptLanguage.JAVASCRIPT, sel.parentStory, UndoModes.ENTIRE_SCRIPT, "Colorize");
    //colorize(sel.parentStory);
}
else {
    app.doScript(colorize, ScriptLanguage.JAVASCRIPT, sel, UndoModes.ENTIRE_SCRIPT, "Colorize");
    //colorize(sel);
}


function colorize(ps) {
    for (l = 0; l < ps.lines.length; l++) {
        if (ps.lines[l].words.length < 1) continue;
        if (ps.lines[l].words[-1].lines.length > 1) {
            //ps.lines[l].words[-1].fillColor = (ps.lines[l].words[-1].fillColor.name == "Black") ? "Hyphenated" : "Black";
            ps.lines[l].words[-1].fillColor = "Hyphenated_AA";
        }
    }

    // * FOOTNOTE CODE BETA -- ONLY COLORS (NO TOGGLE)
    fns = ps.footnotes.everyItem().texts;
    for (fn = 0; fn < fns.length; fn++) {
        pss = fns[fn].texts[0];

        for (l = 0; l < pss.lines.length - 1; l++) {
            if (pss.lines[l].words.length < 1) continue;
            if (pss.lines[l].words[-1].lines.length > 1) {
                pss.lines[l].words[-1].fillColor = "Hyphenated_AA"
                //ps.lines[l].words[-1].fillColor = (ps.lines[l].words[-1].fillColor.name == "Black") ? "Hyphenated" : "Black";
            }
        }
    }
    // * END FOOTNOTE BETA
}